package src.ItemStore;

import java.io.BufferedReader;
import java.io.File;
import java.io.FileNotFoundException;

import java.io.IOException;

/**
 * @author Ben Leov
 */
public class FileReader {

	private String file = "";

	private int processBlockSize;

	private int currentLine;

	private java.io.FileReader fr;

	private BufferedReader br;

	private File inputFile;

	public FileReader(File inputFile, int processBlockSize) {

		this.processBlockSize = processBlockSize;
		currentLine = 0;
		this.inputFile = inputFile;

		try {
			fr = new java.io.FileReader(inputFile);
		} catch (FileNotFoundException e) {
			e.printStackTrace();
		}
		br = new BufferedReader(fr, 8192);

	}

	public String readLine() {

		String line = null;
		try {
			line = br.readLine();

			if (line == null) {// EFO
				br.close();
				fr.close();
				return null;
			}

		} catch (IOException e) {

			e.printStackTrace();
		}

		currentLine++;
		return line;

	}

	public String readAllFile() {

		String toReturn = "", toAdd = "";

		for (;;) {
			toAdd = this.readNextFileBlock();

			if (toAdd == null)
				break;

			// System.out.println("TO ADD FR: " + toAdd);
			toReturn += toAdd;

		}
		System.out.println("FR: Total Number of Lines Read: " + currentLine);
		return toReturn;
	}

	/** read the next block into the cache. */
	public String readNextFileBlock() {
		int count = 0;
		file = "";
		try {
			// System.out.println("FILE READER MISSING LAST ITEM!!");
			// TODO: FILEREADER IS MISSING THE LAST ITEM
			while (count < processBlockSize) {

				String line = br.readLine();

				if (line == null) {// EFO
					System.out.println("IO:FileReader: END OF FILE.");
					br.close();
					fr.close();
					return null;
				}

				// System.out.println("LINE:" + line);
				file += line + "\n";
				count++;
				// System.out.println("X:" + x);
				// x++;

			}

			currentLine += processBlockSize;

			return file;
			// return true;

		} catch (IOException fne) {

			System.out.println(fne.getMessage());
			return null;
		}

	}

	/** Get the current data that has been read into the cache. */
	public String getCurrentFileBlock() {

		return file;

	}

	// TODO Auto-generated constructor stub

}
