package src.limim08;
import java.net.*;
import java.util.*;
import javax.swing.*; 

public class CServerThread extends Thread {
	
  private DefaultListModel listModel;
  private LinkedList buddylist;
  public int status;
  private DatagramSocket socket;
  public boolean stop;

  public static final int ERROR = -1;
  public static final int OK = 1;
  
  CServerThread( DefaultListModel mylistModel, LinkedList blist) {

      listModel = mylistModel;
      buddylist = blist;
      status = 0;
      stop = false;

     try{  
	      socket = new DatagramSocket(6600);		//MIM UDP port
	      status = OK; //ok no socket creation exception
     }
     catch (SocketException scke) {
       status = ERROR; //socket creation exception
       JOptionPane.showMessageDialog(null,"Error! Cannot initialize.\nMaybe your firewall is blocking port 6600 or you have another instance of MIM already running.");  
 }
      
  }
  
  public void run() {
   try{	
	   
    DatagramPacket packet = new DatagramPacket(new byte[512],512);

    while ( !stop ) {
    	
      socket.receive( packet ); //This blocks all the other threads.
      //System.out.println( ""+new Date()+" "+packet.getAddress()+":"+packet.getPort()+" "+new String(packet.getData(),0,packet.getLength()) );
      //socket.send( packet );
      
      String data = new String(packet.getData(),0,packet.getLength());
      String pdata[];
      
      pdata = data.split(" ");
      
      //parsing pdata
      if (pdata[0].compareTo("NEWBUDDYONLINE") == 0)
      {
          Buddy t_buddy = new Buddy();
          t_buddy.Nick = pdata[1];
          t_buddy.Ip = pdata[2];
          buddylist.add(t_buddy);
          listModel.addElement(pdata[1]);
      }
      if (pdata[0].compareTo("MSG") == 0)
      {
          String tmsg = "";
          for (int i=2; i<pdata.length; i++)
          {
              tmsg = tmsg + pdata[i] + " ";
          }
           //find the buddy with id == index
          Buddy tbuddy = null;
          boolean found = false;
          Iterator iter = buddylist.iterator();
          while (iter.hasNext())
           {
             tbuddy = (Buddy) iter.next();
             if (tbuddy.Nick.compareToIgnoreCase(pdata[1]) == 0)
             {
                 found = true;
                 break;
             }
           }
          if (found == true)
          {
              InMsg inmsg = new InMsg(tbuddy, tmsg);
          }
          else
              JOptionPane.showMessageDialog(null,"Message from a buddy not in the buddylist.");
          
      }
      if (pdata[0].compareTo("BUDDYLOGOFF") == 0)
      {
            //find the buddy with id == index in buddylist
          Buddy tbuddy = null;
          Iterator iter = buddylist.iterator();
          while (iter.hasNext())
           {
             tbuddy = (Buddy) iter.next();
             if (tbuddy.Nick.compareToIgnoreCase(pdata[1]) == 0)
             {
                 tbuddy.msgwindow.logoff();
                 iter.remove();
                 break;
             }
           }
          
          //now search in JList
          int index = listModel.indexOf(pdata[1]);
          if (index != -1)
              listModel.remove(index);
          
      }
      	
    }
    socket.close();
 }
   catch (Exception e)
   {
       JOptionPane.showMessageDialog(null,"Error! General socket exception.");  
   }
	  
  }
  
  protected void finalize(){
	  
	  socket.close();
	  
  }
  
  public int getStatus(){
	  return status;
  }
  
  public void CloseSocket(){
          if (!socket.isClosed())
              socket.close();
  }
  /*
  public void setBuddyList(LinkedList list){
	  this.buddylist=list;
	  
  }
  public void setListModel(DefaultListModel lm){
	  this.listModel=lm;
  }
*/
}

