package src.limim08;

import java.io.*;
import java.net.*;
import java.util.Timer;
import java.util.TimerTask;

public class LoginHandler {
	
  private int loginstatus;
  private String hostname; //MC  
  private int port;
  public static final int LOGIN_SUCCESSFUL = 1; //MC - EDIT 07
  public static final int LOGIN_UNSUCCESFUL = 0; //MC - EDIT 07
  
  private LoginProgress lp;
  
  /** Connects to server with username and password. If succesful, it sets its login status */
  public LoginHandler(String username, String password, String hostname, int port){
	try {
 
		this.hostname=hostname;
		this.port=port;
		
           /* Show progress dialog box. */
            lp = new LoginProgress(hostname,"Connecting to server...");
            lp.start();
        
	    loginstatus = LOGIN_UNSUCCESFUL;
		
        // Construct data
        String data = URLEncoder.encode("username", "UTF-8") + "=" + URLEncoder.encode(username, "UTF-8");
        data += "&" + URLEncoder.encode("password", "UTF-8") + "=" + URLEncoder.encode(password, "UTF-8");

        //int port = 80;
        InetAddress addr = InetAddress.getByName(hostname);
        Socket socket = new Socket(addr, port);
    
        // Send header
        String path = "/mim/login.php";
        BufferedWriter wr = new BufferedWriter(new OutputStreamWriter(socket.getOutputStream(), "UTF8"));
        wr.write("POST "+path+" HTTP/1.0\r\n");
        wr.write("Content-Length: "+data.length()+"\r\n");
        wr.write("Host: www.edronsoft.com\r\n");
        wr.write("Content-Type: application/x-www-form-urlencoded\r\n");
        wr.write("\r\n");
    
        // Send data
        wr.write(data);
        wr.flush();

        // Get response
        BufferedReader rd = new BufferedReader(new InputStreamReader(socket.getInputStream()));
        String line;
        

        
        while ((line = rd.readLine()) != null) {
            if (line.indexOf("MIM_OK: LOGIN SUCCESSFUL", 0) != -1)
             {
	             loginstatus = LOGIN_SUCCESSFUL;  //LOGIN_OK
	             break;
             }
        }
        wr.close();
        rd.close();
    } catch (Exception e) {
    }
}

	public int getStatus(){
		return loginstatus;	
	}
	/** Removes the jframe and destroys the process that shows a indetermined progress
	 *  bar after waiting int specified by wait */
	public void removeProgressIndicator(int seconds){
		
		Timer t = new Timer();
		t.schedule(new StopIndicatorTask(lp), seconds*1000);


} 
	public LoginProgress getLoginProgress(){
		return lp;
	}

	public String getHostname() {
		return hostname;
	}

	public void setHostname(String hostname) {
		this.hostname = hostname;
	}

	public int getPort() {
		return port;
	}

	public void setPort(int port) {
		this.port = port;
	}
	
	
	
	
}

 class StopIndicatorTask extends TimerTask {

	 private LoginProgress lp;
	public StopIndicatorTask(LoginProgress lp){
		 lp.getJProgressBar().setIndeterminate(false);
		this.lp=lp;
	}
	
	public void run(){
	lp.getJFrame().dispose();
	lp.stop();
	
	}
	
	
	
}
