/*
 * mainwindow.java
 *
 * Created on 5 settembre 2005, 0.06
 *
 * To change this template, choose Tools | Options and locate the template under
 * the Source Creation and Management node. Right-click the template and choose
 * Open. You can then make changes to the template in the Source Editor.
 */

package src.limim08;


import java.lang.Thread.*;

/**
 *
 * @author Emanuele Pedrona
 */
import javax.swing.*; 
import java.awt.*;
import java.awt.event.*;       
import javax.swing.event.*;
import java.util.*;

/** Inital window showing buddys logged in (JList), and a login/logout button. */

public class MainWindow extends JPanel implements WindowListener{
        
    private JButton logoutButton;
    private JButton loginButton;    
    private JTextField username_text;
    private JTextField password_text;
    private DefaultListModel listModel;
    private LinkedList buddylist;
    private JLabel loginLabel;
    private CServerThread udpthread;
    
	
    public MainWindow(){
	    
	super(new BorderLayout());
	
	JPanel menuLabel = new JPanel(new BorderLayout());
	
	menuLabel.add(new MenuBar(),BorderLayout.NORTH);
	
	JLabel TitleLabel = new JLabel("Your friends : ");
    TitleLabel.setHorizontalAlignment(SwingConstants.CENTER);
    menuLabel.add(TitleLabel, BorderLayout.CENTER);
    
    add(menuLabel,BorderLayout.NORTH);
	
	 
	listModel = new DefaultListModel();
	final JList list = new JList(listModel);
	list.setSelectionMode(ListSelectionModel.SINGLE_SELECTION);
        list.setSelectedIndex(0);
        list.setVisibleRowCount(18);

    
	JScrollPane listScroller = new JScrollPane(list);
	listScroller.setPreferredSize(new Dimension(250, 320));
	
	
	MouseListener mouseListener = new MouseAdapter() {
     	
		/* ERROR when double clicking not logged in. */
		
        public void mouseClicked(MouseEvent e) {
        	
         if (e.getClickCount() == 2) {
             int index = list.locationToIndex(e.getPoint());
             
             if(index == -1){
             return;
             }
             
             String nick_hit = (String) listModel.getElementAt(index);
             //find the buddy with id == index
              Buddy tbuddy = null;
              Iterator iter = buddylist.iterator();
              while (iter.hasNext())
              {
                tbuddy = (Buddy) iter.next();
                if (tbuddy.Nick == nick_hit) break;
              }
              MessageWindow msgwnd;
              if (tbuddy.msgwindow == null)
              {
                  msgwnd = new MessageWindow(tbuddy);
                  tbuddy.msgwindow = msgwnd;
              }
              else
                  msgwnd = tbuddy.msgwindow;
              msgwnd.setTitle("Message Window : messaging with " + tbuddy.Nick + " ...");
              msgwnd.setVisible(true);
     		}
            }
 		};
        
 	list.addMouseListener(mouseListener);	
 		
 	loginButton = new JButton("Login");
 	loginButton.setActionCommand("Login");  
 	loginButton.addActionListener(new LoginListener());  
 		
 	logoutButton = new JButton("Logout");
 	logoutButton.setActionCommand("Logout");
 	logoutButton.addActionListener(new LogoutListener()); 
 	logoutButton.setEnabled(false);
        
        loginLabel = new JLabel("Logging in...");
        loginLabel.setVisible(false);
 		
 	JPanel buttonPane = new JPanel();
        buttonPane.setLayout(new BoxLayout(buttonPane,
                                           BoxLayout.LINE_AXIS));
        
        buttonPane.add(loginButton);
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(new JSeparator(SwingConstants.HORIZONTAL));
        buttonPane.add(Box.createHorizontalStrut(5));
        buttonPane.add(loginLabel);
        buttonPane.add(logoutButton);
        buttonPane.setBorder(BorderFactory.createEmptyBorder(5,5,5,5));
	                          

        add(listScroller, BorderLayout.CENTER);	 
        add(buttonPane, BorderLayout.PAGE_END);    
        
        
        Main.frame.addWindowListener(this);
    }
    
    public void windowClosing(WindowEvent e) {
        CLogout tlogout;
        
        if (Main.person.loginStatus == 1)
        tlogout = new CLogout(Main.person.username, Main.person.password);
        System.exit(0);     
    }       
    //This will only be seen on standard output.
   public void windowClosed(WindowEvent e) {   
    }
    public void windowOpened(WindowEvent e) {
    }
    public void windowIconified(WindowEvent e) { 
    }
    public void windowDeiconified(WindowEvent e) { 
    }
    public void windowActivated(WindowEvent e) {
    }
    public void windowDeactivated(WindowEvent e) { 
    }
    public void windowGainedFocus(WindowEvent e) {  
    }
    public void windowLostFocus(WindowEvent e) { 
    }
    public void windowStateChanged(WindowEvent e) {  
    }
    /*  Login button Action Listener. */
    class LoginListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {

       
	        username_text = new JTextField(10);
	        username_text.setText(Main.preferences.getUsername());
	        
	        password_text = new JPasswordField(10);
	        password_text.setText(Main.preferences.getPassword());
	        
	        String msgString1 = "Please enter login information:"; //MC 
	        String msgString2 = "Username: ";
	        String msgString3 = "Password: ";
	        
	        String btnString1 = "Enter";
     		String btnString2 = "Cancel";
	        
			Object[] array = {msgString1, msgString2, username_text, msgString3, password_text};
			Object[] options = {btnString1, btnString2};
			
            int ret = JOptionPane.showOptionDialog(null,array,"MIM LOGIN",JOptionPane.YES_NO_OPTION,JOptionPane.QUESTION_MESSAGE, null, options, options[0]);
        	     
        	String username = username_text.getText();
        	String passwd = password_text.getText();
   		
            if((username.compareTo("")==0 || passwd.compareTo("")==0) && ret != JOptionPane.NO_OPTION){
                JOptionPane.showMessageDialog(null,"Invalid username or password.");
                return;
            }
            
            if ((ret != JOptionPane.NO_OPTION) && (ret != JOptionPane.CLOSED_OPTION))
            {	
              
                loginButton.setEnabled(false);
                loginLabel.setVisible(true);
                //creates udp server thread
                buddylist = new LinkedList();
            	
      		   udpthread = new CServerThread(listModel, buddylist);
     		   
                if (udpthread.getStatus() == CServerThread.ERROR) 
                {
                    loginButton.setEnabled(true);
                    loginLabel.setVisible(false);
                    return;
                } 
                udpthread.start();

           	/* Creating LoginHandler thread... */
               
                 final SwingWorker worker = new SwingWorker(){
              	   
              	   public Object construct(){
              		 
              		 LoginHandler tlogin = new LoginHandler(username_text.getText(), password_text.getText(),Main.preferences.getServer(),Main.preferences.getServerPort());
              		
              		 int status = tlogin.getStatus();
              		 

                	if (status == LoginHandler.LOGIN_SUCCESSFUL) //Login successful
                	 {
                		tlogin.getLoginProgress().setMessage("Login Success!");            		
                		tlogin.removeProgressIndicator(2);
                		Main.person.loginStatus = 1;
                		Main.person.username = username_text.getText();
                		Main.person.password = password_text.getText();
                		logoutButton.setEnabled(true);
                		loginButton.setEnabled(false);
                		
            		}
                	else
                	{
                		tlogin.getLoginProgress().setMessage("Wrong credentials or could not contact server. Please retry.");
                		tlogin.removeProgressIndicator(2);
                		
                                udpthread.CloseSocket();
                                udpthread.stop();//TODO: DEPRECIATED METHOD. 
                	  
                                Main.person.loginStatus = 0;
                                Main.person.username = "";
                                Main.person.password = "";
                                logoutButton.setEnabled(false);
                                loginButton.setEnabled(true);
                        }
              		 return tlogin;
                       }  		 
                 };
                 worker.start();   
                 
                 loginLabel.setVisible(false);      
            }  
        }
 }     
    class LogoutListener implements ActionListener {
        public void actionPerformed(ActionEvent e) {
            CLogout tlogout = new CLogout(Main.person.username, Main.person.password);
            udpthread.stop = true;
            Main.person.loginStatus = 0;
            Main.person.username = "";
            Main.person.password = "";
            logoutButton.setEnabled(false);
            loginButton.setEnabled(true);
            listModel.clear();
        }
    }
}
