package src.limim08;

import java.awt.Dimension;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;

/** @author Ben Leov
 * 
 *  The menu bar is displayed across the top of the MainWindow JFrame. It allows the user access to 
 *  the Preferences and About windows. */

public class MenuBar extends JMenuBar implements ActionListener {

	
	private static final String PREF_STR = "Preferences";
	private static final String ABOUT_STR = "About";
	private static final String SERV_PRF_STR = "Server";
	
	public MenuBar(){
		
		this.setAlignmentX(JMenuBar.LEFT_ALIGNMENT);
		JMenu prefMenu= new JMenu(PREF_STR);
		JMenuItem serverPrefs = new JMenuItem(SERV_PRF_STR);
		
		prefMenu.add(serverPrefs);
		JMenuItem about = new JMenuItem(ABOUT_STR);  
		
		serverPrefs.addActionListener(this);
		about.addActionListener(this);
		
		this.add(about);
		this.add(prefMenu);
		
	}
	
	
	public void actionPerformed(ActionEvent e){
		
		JMenuItem jme = (JMenuItem)e.getSource();

		if(jme.getLabel().compareTo(SERV_PRF_STR)==0) {
			
		PreferenceWindow.getPreferenceWindow();//Display current Preferences
		
		} if(jme.getLabel().compareTo(ABOUT_STR)==0){
			 JOptionPane.showMessageDialog(null,"LiMiM version " + Main.VERSION);  //About
			 
		}
	}
	
}
