/*
 * MessageWindow.java
 *
 * Created on 5 settembre 2005, 1.59
 */

package src.limim08;


import javax.swing.text.*;


/**
 *
 * @author  Emanuele Pedrona
 */
public class MessageWindow extends javax.swing.JFrame {
    
    private Buddy buddy;
    public  Style msgarea_stylenormal;
    public Style msgarea_stylebold;
    public Style msgarea_styleaction;
    public StyledDocument msgarea_doc;
    
    /** Creates new form MessageWindow */
    public MessageWindow(Buddy mybuddy) {
        buddy = mybuddy;
        initComponents();
        this.setLocationRelativeTo(null);
        MsgAreaScrollPane.setViewportView(MsgArea);
        NewMsgFieldScrollPane.setViewportView(NewMsgField);
        
        msgarea_doc = MsgArea.getStyledDocument();
        msgarea_stylenormal = msgarea_doc.addStyle("StyleNormal", null);
        msgarea_stylebold = msgarea_doc.addStyle("StyleBold", null);
        msgarea_styleaction = msgarea_doc.addStyle("StyleAction", null);
        
        StyleConstants.setBold(msgarea_stylenormal, false);
        StyleConstants.setBold(msgarea_stylebold, true);
        StyleConstants.setForeground(msgarea_stylenormal, java.awt.Color.black);
        StyleConstants.setForeground(msgarea_stylebold, java.awt.Color.black);
        StyleConstants.setForeground(msgarea_styleaction, java.awt.Color.red);
        StyleConstants.setItalic(msgarea_stylenormal, false);
        StyleConstants.setItalic(msgarea_stylebold, false);
        StyleConstants.setItalic(msgarea_styleaction, true);
        
    }
    
    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    // <editor-fold defaultstate="collapsed" desc=" Generated Code ">//GEN-BEGIN:initComponents
    private void initComponents() {
        PanelNorth = new javax.swing.JPanel();
        MsgAreaScrollPane = new javax.swing.JScrollPane();
        MsgArea = new javax.swing.JTextPane();
        PanelSouth = new javax.swing.JPanel();
        SendButton = new javax.swing.JButton();
        jSeparator1 = new javax.swing.JSeparator();
        NewMsgField = new javax.swing.JTextArea();
        NewMsgFieldScrollPane = new javax.swing.JScrollPane();

        setDefaultCloseOperation(javax.swing.WindowConstants.DISPOSE_ON_CLOSE);
        setTitle("Message Window");
        addWindowListener(new java.awt.event.WindowAdapter() {
            public void windowClosed(java.awt.event.WindowEvent evt) {
                formWindowClosed(evt);
            }
            public void windowOpened(java.awt.event.WindowEvent evt) {
                formWindowOpened(evt);
            }
        });

        PanelNorth.setLayout(new javax.swing.BoxLayout(PanelNorth, javax.swing.BoxLayout.X_AXIS));

        MsgAreaScrollPane.setAutoscrolls(true);
        PanelNorth.add(MsgAreaScrollPane);

        MsgArea.setEditable(false);
        MsgArea.setPreferredSize(new java.awt.Dimension(7, 200));
        PanelNorth.add(MsgArea);

        getContentPane().add(PanelNorth, java.awt.BorderLayout.CENTER);

        PanelSouth.setLayout(new java.awt.BorderLayout());

        SendButton.setText("Send");
        SendButton.addMouseListener(new java.awt.event.MouseAdapter() {
            public void mouseClicked(java.awt.event.MouseEvent evt) {
                btnclicked(evt);
            }
        });

        PanelSouth.add(SendButton, java.awt.BorderLayout.EAST);

        PanelSouth.add(jSeparator1, java.awt.BorderLayout.NORTH);

        NewMsgField.setColumns(45);
        NewMsgField.setLineWrap(true);
        NewMsgField.setRows(2);
        NewMsgField.setWrapStyleWord(true);
        NewMsgField.addKeyListener(new java.awt.event.KeyAdapter() {
            public void keyPressed(java.awt.event.KeyEvent evt) {
                NewMsgFieldKeyPressed(evt);
            }
        });

        PanelSouth.add(NewMsgField, java.awt.BorderLayout.WEST);

        NewMsgFieldScrollPane.setAutoscrolls(true);
        PanelSouth.add(NewMsgFieldScrollPane, java.awt.BorderLayout.CENTER);

        getContentPane().add(PanelSouth, java.awt.BorderLayout.SOUTH);

        pack();
    }
    // </editor-fold>//GEN-END:initComponents

    private void NewMsgFieldKeyPressed(java.awt.event.KeyEvent evt) {//GEN-FIRST:event_NewMsgFieldKeyPressed
// TODO add your handling code here:
        if (evt.getKeyCode() == java.awt.event.KeyEvent.VK_ENTER)
         {
           if (!evt.isShiftDown()) 
           {
            btnclicked(null);
            evt.consume();
           }
           else //add new line
            NewMsgField.append("\n");
         }
    }//GEN-LAST:event_NewMsgFieldKeyPressed

    private void formWindowClosed(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowClosed
// TODO add your handling code here:
        buddy.msgwindow = null;
    }//GEN-LAST:event_formWindowClosed

    private void formWindowOpened(java.awt.event.WindowEvent evt) {//GEN-FIRST:event_formWindowOpened
// TODO add your handling code here:
        NewMsgField.requestFocus();
    }//GEN-LAST:event_formWindowOpened

    private void btnclicked(java.awt.event.MouseEvent evt) {//GEN-FIRST:event_btnclicked
// TODO add your handling code here:
        OutMsg outmsg = new OutMsg(NewMsgField.getText(), buddy);
        //this.dispose();
        
        //set bold
    try{        
        msgarea_doc.insertString(msgarea_doc.getLength(), new String(Main.person.username + ": "), msgarea_stylebold);
        msgarea_doc.insertString(msgarea_doc.getLength(), new String(NewMsgField.getText() + "\n\n"), msgarea_stylenormal);
        scrollMsgArea();
    }   
        catch (BadLocationException e) {
    }
        
        
        
        
       // MsgArea.setText(new String(MsgArea.getText() + Main.username + ": " + NewMsgField.getText() + "\n\n"));
        NewMsgField.setText("");
    }//GEN-LAST:event_btnclicked
    
    /**
     * @param args the command line arguments
     */
 /*   public static void main(String args[]) {
        java.awt.EventQueue.invokeLater(new Runnable() {
            public void run() {
                new MessageWindow().setVisible(true);
            }
        });
    }
 */   
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private javax.swing.JTextPane MsgArea;
    private javax.swing.JScrollPane MsgAreaScrollPane;
    private javax.swing.JTextArea NewMsgField;
    private javax.swing.JScrollPane NewMsgFieldScrollPane;
    private javax.swing.JPanel PanelNorth;
    private javax.swing.JPanel PanelSouth;
    private javax.swing.JButton SendButton;
    private javax.swing.JSeparator jSeparator1;
    // End of variables declaration//GEN-END:variables
   
    public javax.swing.JTextPane GetMsgArea(){
        return MsgArea;
    }
    
    public void scrollMsgArea()
    {
        MsgArea.setCaretPosition(MsgArea.getDocument().getLength());
    }
    
    public void logoff()
    {
        NewMsgField.setEnabled(false);
        SendButton.setEnabled(false);
      try{
        msgarea_doc.insertString(msgarea_doc.getLength(), new String("\n\n// User logged off. This window will be disabled. \\\\"), msgarea_styleaction);
      }
      catch (BadLocationException e){  
      }
        scrollMsgArea();
    }
}
