package src.limim08;

import java.awt.Dimension;
import java.awt.Toolkit;
import java.lang.reflect.InvocationTargetException;
import javax.swing.ImageIcon;
import javax.swing.JLabel;
import javax.swing.JWindow;
import javax.swing.SwingUtilities;
/** JWindow is a lightweight container */

public class SplashScreen extends JWindow {

	private int closeTime;
	private String fileName;
	private Thread splashThread;
	
	public SplashScreen(String fileName,int closeTime){
		
		this.closeTime=closeTime;
		this.fileName=fileName;
		
		JLabel l = new JLabel(new ImageIcon(this.fileName));
		
		this.getContentPane().add(l);
		pack();
		Dimension screenSize = Toolkit.getDefaultToolkit().getScreenSize();
		Dimension labelSize = l.getPreferredSize();
		setLocation(screenSize.width/2 -(labelSize.width/2), screenSize.height/2 - (labelSize.height/2));
		
		final int pause = this.closeTime;
		
		final Runnable closerRunner = new Runnable(){
			public void run(){
				setVisible(false);
				dispose();
			}
		};
	
		
		final Runnable waitRunner = new Runnable(){
			
			public void run(){
			
					try {
						Thread.sleep(pause);
						SwingUtilities.invokeAndWait(closerRunner);
					} catch (InterruptedException e) {
						e.printStackTrace();
					} catch (InvocationTargetException e) {
						e.printStackTrace();
					}

			}
		};
	
		
		splashThread = new Thread(waitRunner,"SplashThread");
		this.toFront();
		setVisible(true);
		splashThread.start();
		
	}
	
	
	
}
